/****************************************************************
Simple source to demonstrate LIME-CUDA.
State is constructed externally.

Copyright 2008 Pjotr Kourzanov

This file is part of LIME.

LIME is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

LIME is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LIME.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************/
#include CUDA

/* Both of these structs are defined externally */
struct source_state;

actor process(unsigned int buf[restrict BUF_SIZE],
	      const struct source_state inst[1],
	      struct source_state outs[1])
{
	unsigned int i;

	for(i=0; i< BUF_SIZE; i++)
	{
		buf[i] = inst->count;
		atomicInc(&outs->count,UINT_MAX);
		/* Wrap on signed 24 bits value */
		atomicAnd(&outs->count,0x7fffff);
	}
}
