##################################################################
# The Pthread BE compilation flow driver (only rules)
#
#Copyright 2008 Pjotr Kourzanov
#
#This file is part of LIME.
#
#LIME is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License version 2
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#LIME is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with LIME.  If not, see <http://www.gnu.org/licenses/>.
##################################################################
include $(lib)/LIME.mk

$d/%-main.c: %.gxf $d $(dep)
	$(inform)
	$e$(gxf2main.c) $< > $@ || $(fail)

$d/Makefile: $(src)/Makefile $d
	$(inform)
	$e$(sed) -s 's/$$(comp)/$(graph:%.graph=%)/g' $< | $(unbundle) -vprefix=$d
	$e$(touch) $@

$d $d/docs:
	$(inform)
	$e$(mkdir) -p $@

define COMP-RULE
$d/docs/$1.pdf: $d/docs
	$(minform)
	$eif [ -r $1.pdf ]; then $(cp) $1.pdf $$@; else $(cp) $1-gen.pdf $$@; fi

$d/docs/$1.html: $d/docs
	$(minform)
	$eif [ -r $1.html ]; then $(cp) $1.html $$@; else $(sed) -e 's,-gen-hier.png,-hier.png,g' $1-gen.html > $$@; fi

$d/docs/$1-hier.png: $d/docs
	$(minform)
	$eif [ -r $1-hier.png ]; then $(cp) $1-hier.png $$@; else $(cp) $1-gen-hier.png $$@; fi

$d/$1-shell.h: $$(graphs) $d/$1.imports $(dep)
	$(minform)
	$e$(gxf2shell.h) -vPE=$1 -vIMPORTS=$$(filter %.imports,$$^) $$< > $$@ || $(fail)

$d/$1-shell.c: $$(graphs) $d/$1.imports $(dep)
	$(minform)
	$e$(gxf2shell.c) -vPE=$1 -vIMPORTS=$$(filter %.imports,$$^) $$<\
		`$(sed) -e 's,$$$$,.types,g;s,^,$d/,g' $$(filter %.imports,$$^)`\
	> $$@ || $(fail)

$d/$1.mod.c: $1.c $d $1.depx.h $1.domains
	$(minform)
	$E$(CC) $(CFLAGS) $$(call dom2hdr,$1.depx.h,$1.domains) $(FLAGS) -E $1.c -o $$@ 

$d/$1.mod.o: $d/$1.mod.c 
	$(minform)
	$E$(CC) $(CFLAGS) -o $$@ -c $$<

$d/$1.module: $1.module $d
	$(minform)
	$e$(cp) $1.module $$@

$d/$1.imports: $1.imports $d
	$(minform)
	$efor i in `$(sed) -e 's,.*,&.h,g' $$(filter %.imports,$$^)`; do\
		[ -r $$$$i ] || continue;\
		[ -d $d ] || continue;\
		$(cp) $$$$i $d;\
	done
	$efor i in `$(sed) -e 's,.*,&.types,g' $$(filter %.imports,$$^)`; do\
		[ -r $$$$i ] || continue;\
		[ -d $d ] || continue;\
		$(cp) $$$$i $d;\
	done
	$e$(sed) 's,.*/,,g' $$< > $$@

endef

$(foreach c,$(comps),$(eval $(call COMP-RULE,$c,$(subst _,,$c))))

