#!/usr/bin/awk -f
##################################################################
# AWK script to query a set of .types files for every type specified
# on the command-line
#
#Copyright 2008 Pjotr Kourzanov
#
#This file is part of LIME.
#
#LIME is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License version 2
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#LIME is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with LIME.  If not, see <http://www.gnu.org/licenses/>.
##################################################################
BEGIN { if (!OP) OP="query"
	if (!NOTRACKFILES) NOTRACKFILES=1
	#print "here",FILE >STDERR
	if (FILE) while ((getline < FILE)>0) query[++nq]=$0	
	# remove .types files that do not exist
if (0)	for (i=1; i<ARGC; i++) if ((getline < ARGV[i])<=0)
		delete ARGV[i]
}

func handle(tag,body) { return handle_types(tag,body) }

{ f=gensub(/.types/,"","g",FILENAME)
  if (!(f in Files)) {
  	files[++nf]=f
  	Files[f]=1
  }
}

END { if (OP=="dump") for (j=1; j<=nf; j++) 
	    for (i=1; i<=ntypes[files[j]]; i++)
		print files[j],types[files[j],i],typedecls[files[j],i]
}

END { if (OP=="query") {
	    for (i=1; i<=nq; i++)  for (j=1; j<=nf; j++) {
#print "looking for",query[i],"in",files[j] >STDERR
	    	if (type_idx[files[j],query[i]]) {
#print "found",query[i],"in",files[j] >STDERR
			print files[j]
			break
		}
	    }
	}
}

@include types-parser.awk
