##################################################################
# AWK script to implement parsing of .types files
#
#Copyright 2008 Pjotr Kourzanov
#
#This file is part of LIME.
#
#LIME is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License version 2
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#LIME is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with LIME.  If not, see <http://www.gnu.org/licenses/>.
##################################################################

func handle_types(tag,body, t,p)
{
#    if (DEBUG) print "TYPES: handling",tag,"in",state >STDERR

    if (tag=="id" && (state ~ /@typedecl$/ ||
		      state ~ /@variant@sel$/ ||
		      state ~ /@variant@ports$/))
	return id[lev]=body

    if (tag=="size" && state ~ /@typedecl$/)
	return typesize[lev]=body

    if (tag=="prec" && state ~ /@typedecl$/)
	return typeprec[lev]=body

    if (tag=="type" && (state ~ /@typedecl$/ ||
			state ~ /@variant@sel$/))
	return type[lev]=body

    if (tag=="sel" && state ~ /@port$/)
    	return sel[lev]=body

    if (tag=="sel" && state ~ /@variant$/)
    {
	seltype[lev]=type[lev+1]
    	return sel[lev]=id[lev+1]
    }

    if (tag=="ports" && state ~ /@variant$/)
    	return uni[lev]=id[lev+1]

    if (tag=="port" && state ~ /@variant$/)
    {
    	t=id[lev-1]
	p=id[lev+1]
    	ports[f,t,++nports[f,t]]=p
	port_type[f,t,p]=type[lev+1]
	port_size[f,t,p]=size[lev+1]
	port_sel[f,t,p]=sel[lev+1]
	delete size
	return body
    }

    if (tag=="variant" && state ~ /@typedecl$/) 
    {
	seltype[lev]=seltype[lev+1]
	sel[lev]=sel[lev+1]
	uni[lev]=uni[lev+1]
    	return body
    }

    if (tag=="typedecl" && state=="@types")
    {
	t=id[lev+1]
	if (DEBUG) print "here",f,t,uni[lev+1],sel[lev+1] >STDERR
	
	types[f,type_idx[f,t]=++ntypes[f]]=t
	typedecls[f,ntypes[f]]=type[lev+1]
	typesizes[f,ntypes[f]]=typesize[lev+1]
	typeprecs[f,ntypes[f]]=typeprec[lev+1]

	if (sel[lev+1]) typesels[f,ntypes[f]]=sel[lev+1]
	if (uni[lev+1]) typeunis[f,ntypes[f]]=uni[lev+1]
	if (seltype[lev+1]) seltype[f,ntypes[f]]=seltype[lev+1]

	delete sel; delete uni

	return body
    }

    if (relax) {
#    	if (DEBUG) print "TYPES: ignoring",tag,"in",state >STDERR
    	return body
    }

    fail("TYPES: unknown tag " tag)
}

# join info on variant records
func merge_types( f,i,t) {
    for (f in files) if (f ~ /.types/) for (i=1; i<=ntypes[f]; i++) 
    {	t=types[f,i]
    	if (typesels[f,i]) {
		variants[t]=f SUBSEP i
		if (DEBUG) print "merged",t,f >STDERR
	}
	if (typeprecs[f,i]) {
		if (typeprecs[i] && typeprecs[t] != typeprecs[f,i]) 
			fail("TYPES: typeprec mismatch for " t ":" typeprecs[t] "!=" typeprecs[f,i])
		else typeprecs[t]=typeprecs[f,i]
	}
	if (typesizes[f,i]) {
		if (typesizes[i] && typesizes[t] != typesizes[f,i])
			fail("TYPES: typesize mismatch " t ":" typesizes[t] "!=" typesizes[f,i])
		else typesizes[t]=typesizes[f,i]
	}
    }
}
@include xml-parser.awk
