/****************************************************************
Simple source to demonstrate LIME
Uses state defined statically.

Copyright 2008 Pjotr Kourzanov

This file is part of LIME.

LIME is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

LIME is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LIME.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************/
#include LIME

/* This struct is defined externally */
struct state;

static struct state _state;
actor process(unsigned int buf[restrict BUF_SIZE])
{
	unsigned int i;

	for(i=0; i< BUF_SIZE; i++)
	{
		buf[i] = _state.count;
		_state.count++;
		/* Wrap on signed 24 bits value */
		_state.count &= 0x7fffff;
	}
}


